from hatchet_sdk import Context

from knoc.hatchet_client import hatchet
from knoc.models.foo import SimpleInput


foo_workflow = hatchet.workflow(name="Foo-workflow", input_validator=SimpleInput)


@foo_workflow.task()
async def first_task(input: SimpleInput, ctx: Context) -> SimpleInput:
    return SimpleInput(message=input.message.upper())


@foo_workflow.task(parents=[first_task])
async def second_task(input: SimpleInput, ctx: Context) -> SimpleInput:
    # Access output from parent task
    first_result = ctx.task_output(first_task)
    return SimpleInput(message=f"Yo {first_result.message}")


@hatchet.task(name="FooTask", input_validator=SimpleInput)
async def foo_task(input: SimpleInput, ctx: Context) -> SimpleInput:
    return SimpleInput(message=f"*** {input.message} ***")


# foo_workflow.add_task(foo_task.to_task())
